default:
  image: docker.libsdev.k-int.com/knowledgeintegration/stripes-build-agent:2.1.0
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - .npm/
      - ./module-descriptor.json
  tags:
    - docker
    - docker-18
    - ki-onprem

stages:
  - release

build:
  stage: release
  only:
    - release
  before_script:
    - npm config set @folio:registry "https://nexus.libsdev.k-int.com/repository/libsdev-npm-group/"
    - npm config set @knowledge-integration:registry "https://nexus.libsdev.k-int.com/repository/libsdev-npm-hosted/"
    - npm config set -- //nexus.libsdev.k-int.com/repository/libsdev-npm-hosted/:_authToken $KI_NEXUS_NPM_TOKEN
    - npm config set -- //nexus.libsdev.k-int.com/repository/libsdev-npm-snapshots-hosted/:_authToken $KI_NEXUS_NPM_TOKEN
  script:
    - export NPM_TOKEN="$NPMJS_TOKEN"
    - echo $NODE_ENV
    - export NODE_ENV=dev
    - git config --global user.name "ianibbo"
    - git config --global user.email "ian.ibbotson@k-int.com"
    - yarn install
    - npx semantic-release
    - yarn build-mod-descriptor
    - echo "token $GITLAB_TOKEN $NPM_TOKEN $KI_NEXUS_NPM_TOKEN"

publish-module-descriptor:
  stage: release
  needs:
    - "build"
  only:
    - release
  before_script:
    export REG_AUTHN="$KI_OKAPI_REG_USER:$KI_OKAPI_REG_PASS"
  script:
    - cat module-descriptor.json
    - 'curl -X POST -H "Content-Type: application/json" --data-binary @module-descriptor.json --user "$REG_AUTHN" "https://folio-registry-rw.k-int.com/_/proxy/modules"'
